package BankClient; 

import ServerConfig.*;

import java.io.*;
import java.net.*;
import java.util.*;

import BankApp.BankException.*;
import BankApp.*;

import java.util.concurrent.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.ORB.*;
import org.omg.CORBA.*;



public class BankClient
{
	public static ServerConfig currentConfig = null;
	//protected static String branchHostNames[];
	//protected static Bank banks[];
	protected static String hostName;
	protected static int sequenceNo=10000;

	//actually this is a fake processID, since i cannot find the method, I have to use time to represent.
	protected static String processID = "";//I have to make it fixed length
	protected static String uniqueID = ""; // The uniqueID for this execution

	protected static int RunningThreadNumber=5;
	protected static int counter=0;
	protected static TransferThread transferThread0[], transferThread1[], transferThread2[];
	//protected static TransferThread doubleThread0[], doubleThread1[];
	protected static RunningThread deposits[];
	protected static RunningThread withdraws[];
	protected static CyclicBarrier tripleBarrier=new CyclicBarrier(RunningThreadNumber*3); 
	protected static CyclicBarrier doubleBarrier=new CyclicBarrier(RunningThreadNumber*2); 
	

	//protected static Bank h;
	protected static Random rand=new Random();
	protected static final String menuStr
		="\nPlease input your choice:\nOpen(1), Deposit(2), Withdraw(3), Balance(4), Transfer(5), Exit(6)";
	
	protected static BufferedReader bufInput;
	
	protected static NamingContextExt ncRef;

	protected static ORB orb;
	
	public static int Open()
	{
		int result=BankUtility.InvalidAccountNumber;
		boolean done=false;
		String branchList[] = null;
		String opID=getOpID();
		while (!done)
		{
			try
			{
				try
				{
					branchList = ServerConfig.listServers(currentConfig.rootContext);
				}
				catch(Exception e)
				{
					System.out.println("Central Naming Service access failed.");
					return BankUtility.InvalidAccountNumber;
				}
				
				int branchID = 0;
				try
				{
					branchID = Integer.parseInt(branchList[rand.nextInt(branchList.length)].substring(6,9));
				}
				catch(Exception e){}
				int account=(branchID)*10000;
				Bank h=getInterface(account);				
				result= h.Open(opID);	
				done=true;
			}
			catch (Exception er)
			{
				done=false;
			}
		}
		return result;
	}

	public static float Deposit(int account, float amount) 
	{
		float result=BankUtility.NegativeInfinite;
		boolean done=false;
		String opID=getOpID();
		while (!done)
		{
			try
			{
				Bank h=getInterface(account);				
				result= h.Deposit(opID, account, amount);
				done=true;
			}
			catch (Exception er)
			{
				done=false;
			}
		}
		return result;
	}

	public static float Withdraw(int account, float amount)
	{
		float result=BankUtility.NegativeInfinite;
		boolean done=false;
		String opID=getOpID();
		while (!done)
		{
			try
			{
				Bank h=getInterface(account);
				
				result= h.Withdraw(opID, account, amount);
				done=true;
			}
			catch (Exception er)
			{
				done=false;
			}
		}
		return result;
	}

	public static float Balance(int account)
	{
		float result=BankUtility.NegativeInfinite;
		boolean done=false;
		String opID=getOpID();
		while (!done)
		{
			try
			{
				Bank h=getInterface(account);				
				result= h.Balance(opID, account);
				done=true;
			}
			catch (Exception er)
			{
				done=false;
			}
		}
		return result;
	}

	public static float Transfer(int source, int dest, float amount)
	{
		float result=BankUtility.NegativeInfinite;
		boolean done=false;
		String opID=getOpID();
		while (!done)
		{
			try
			{
				Bank h=getInterface(source);				
				result= h.Transfer(opID, source, dest, amount);
				done=true;
			}
			catch (Exception er)
			{
				done=false;
			}
		}
		return result;
	}

	protected static boolean checkAccount(int account)
	{
		int result=account/10000;
		return result>=0&&result<BankUtility.MaxBranchNumber;
	}
	
	//since the method which is calling this method is already synchronized, we don't have to use semaphore any more
	protected synchronized static Bank getInterface(int account)throws java.rmi.RemoteException
	{
		//for testing
		Bank h;
		int branchIndex=account/10000;
		
		if (branchIndex>=BankUtility.MaxBranchNumber-1||branchIndex<0)
		{
			throw new BankException("branch number invalid");
		}
		try
		{
			String zeros = "000";
			String branchID = String.format("%1$3d",branchIndex).trim();
			if(branchID.length()<3){
				branchID = zeros.substring(0,3-branchID.length())+branchID;
			}
			
			NamingContext ctx2 = NamingContextExtHelper.narrow(currentConfig.rootContext.resolve_str(ServerConfig.branchDirectory));
			ctx2 = NamingContextExtHelper.narrow(((NamingContextExt)ctx2).resolve_str(ServerConfig.branchTag+branchID));
			h=BankHelper.narrow(((NamingContextExt)ctx2).resolve_str(ServerConfig.PrimaryTag));
		}
		catch(Exception er)
		{
			throw new BankException(er.getMessage());
		}
		if (h==null)
		{
			throw new BankException("cannot bind branch"+(branchIndex+100));
		}
		return h;		
	}

	//a synchronized method
	protected synchronized static String getOpID()
	{
		// Try to get a unique ID from central naming service
		
		try{
			if(BankClient.uniqueID.length()<10){
				BankClient.uniqueID = ServerConfig.getUniqueID(currentConfig.rootContext);
			}
			sequenceNo++;
			if (sequenceNo==100000)
			{
				// Local sequence number run out
				// Get another unique ID from central naming service
				BankClient.uniqueID = ServerConfig.getUniqueID(currentConfig.rootContext);
				sequenceNo=10000;
			}
		}catch(Exception e){
			// Error while retrieve unique ID
			System.out.println("Error while retrieve unique ID");
			uniqueID = String.format("%1$" + BankUtility.OpIDPrefixLength + "d",((long)-1)); 
		}
		//return processID+sequenceNo;
		return uniqueID + sequenceNo;
	}


	public static void main(String args[])
	{
		boolean running = false;
		// Read central naming service configure
		currentConfig = new ServerConfig();
		try{
			currentConfig.readNSFromFile();
		}catch(Exception e){
			System.out.println("Reading naming service configure file failed. Quit.");
			System.exit(1);
		}
		
		try
		{
			
			//hostName=BankUtility.getHostName();
						
			hostName=InetAddress.getLocalHost().getHostName();
			
			long pid=System.currentTimeMillis();
			//char[] array=new char[BankUtility.OpIDPrefixLength];
			String temp=hostName+pid+"                                ";
			processID=String.copyValueOf(temp.toCharArray(), 0, BankUtility.OpIDPrefixLength);
			

			// Retrieve the central naming service
			Properties props = new Properties();
			props.put("org.omg.CORBA.ORBInitialPort", ServerConfig.centralNCInitialPort);
			props.put("org.omg.CORBA.ORBInitialHost", ServerConfig.centralNCInitialHost);
			String empty[] = new String[0];
			orb = ORB.init(empty, props);
			currentConfig.setServerConfig(orb);

			ncRef= currentConfig.rootContext;
			
			bufInput = new BufferedReader(new InputStreamReader(System.in));
			
			// test
			BankUtility.showDebugInfo(1,"The unique operation id prefix is " + BankClient.getOpID().substring(0,BankUtility.OpIDPrefixLength));
			
			
			manualTester();
			oneWayTester();
			threadTester();
			transferTester();
			pairTransferTester();
			//autoTester();									
		}
		catch(Exception er)
		{
			System.out.println(er.getMessage());
		}
	}

	static void oneWayTester()
	{
		int account1, account2;
		int RunningNumber=10;
		float InitialAmount=50000;
		account1=getAccount(1);
		account2=getAccount(2);
					

		System.out.println("one way test begins and we deposit 5000.0 to each account "
			+ " and we are going to run some number transfer of 50 each from account "+ account1+ " to account " + account2+
			" later we will transfer same number of transfer back from account "+ account2 +" to account "+account1+
			" if server is not properly synchronized and fault tolerant, the balance will not be the same probably ");
		Deposit(account1, InitialAmount);
		Deposit(account2, InitialAmount);
		System.out.println("account "+account1+" has balance of "+Balance(account1));
		System.out.println("account "+account2+" has balance of "+Balance(account2));
		int counter=0;
		while(counter<RunningNumber)
		{
			if (Transfer(account1, account2, 50)!=BankUtility.NegativeInfinite)
			{
				counter++;
				System.out.println("transfer from account "+account1 +" to account "+ account2+" succeed");			
			}
		}
		counter=0;
		
		while(counter<RunningNumber)
		{
			if (Transfer(account2, account1, 50)!=BankUtility.NegativeInfinite)
			{
				counter++;
				System.out.println("transfer from account "+account2 +" to account "+ account1+" succeed");			
			}
		}
		
	

		System.out.println("now let's check if two accounts have same balance");
		System.out.println("account "+ account1+" has balance of "+Balance(account1));
		System.out.println("account "+ account2+" has balance of "+Balance(account2));	
	}
	
	//a helper class of thread to test mutual exclusion in server
	static class RunningThread extends Thread 
	{
		protected float amount, newAmount;
		protected int account;
		//protected BankInterface bankInterface;
		public RunningThread(int acnt,  float amt)
		{
			amount=amt;
			account=acnt;			
		}

		public void run()
		{			
			try
			{
				doubleBarrier.await();
				if (amount>0)
				{					
					System.out.println(getName()+ " reports to deposit "+Float.toString(amount) +
						" to account " + Integer.toString(account) +" and balance is " + 
						Float.toString(Deposit(account, amount)));					
				}
				else
				{					
					System.out.println(getName()+ " reports to withdraw "+Float.toString(-amount) +
						" to account " + Integer.toString(account)+ " and balance is " +
						Float.toString(Withdraw(account, -amount)));					
				}
			}
			catch (Exception er)
			{
				System.out.println(er.getMessage());
			}
		}
	}
	


	protected static int getAccount(int index)
	{
		int result;
		while (true)
		{
			result=(int)BankUtility.NegativeInfinite;
			try
			{
				result=Open();
			}
			catch(Exception er)
			{
				System.out.println("get account error of :"+er.getMessage());
			}
			if (result/10000==index)
			{
				break;
			}
		}
		return result;
	}

	static class TransferThread extends Thread 
	{
		protected float amount;
		protected int source, destination;
		//protected BankInterface bankInterface;
		public TransferThread(int src, int dest,  float amt)
		{
			amount=amt;
			source=src;
			destination=dest;			
		}

		public void run()
		{		
			float newAmount, myAmount=amount;
			int mySource=source, myDest=destination;
			try
			{				
				tripleBarrier.await();
			
				do
				{
					newAmount=Transfer(mySource, myDest, myAmount);					
					//System.out.println(getName()+" fail in transfer from "+source+" to "+destination);
					if (newAmount==BankUtility.NegativeInfinite)
					{
						Thread.sleep(1000);
					}
					else
					{
						break;
					}
				}while (true);

				System.out.println(getName()+" succeed in transfer from "+mySource+" to "+myDest+ " and balance of "+source+" should be " 
					+newAmount);
				/*
				System.out.println(" and let's check " + source + " is "+Balance(source)+ " and " +destination+ " is "+Balance(destination));
				*/
				counter++;
			}
			catch (Exception er)
			{
				System.out.println("transfer thread in run error of  what ? "+ er.getMessage());
			}
		}
	}


	
	static class PairTransferThread extends Thread
	{
		protected float amount, newAmount;
		protected int source, destination;
		//protected BankInterface bankInterface;
		public PairTransferThread(int src, int dest,  float amt)
		{
			amount=amt;
			source=src;
			destination=dest;			
		}

		public void run()
		{					
			try
			{				
				doubleBarrier.await();
			
				do
				{
					newAmount=Transfer(source, destination, amount);					
					//System.out.println(getName()+" fail in transfer from "+source+" to "+destination);
					if (newAmount==BankUtility.NegativeInfinite)
					{
						System.out.println("Failed");
						Thread.sleep(1000);
					}
					else
					{
						System.out.println("Succeeded");
						break;
					}
				}while (true);

				System.out.println(getName()+" succeed in transfer from "+source+" to "+destination+ " and balance of "+source+" should be " 
					+newAmount);
				/*
				 System.out.println(" and let's check " + source + " is "+Balance(source)+ " and " +destination+ " is "+Balance(destination));
				 */
				counter++;
			}
			catch (Exception er)
			{
				System.out.println("transfer thread in run error of  what ? "+ er.getMessage());
			}
		}
	}


	protected static void pairTransferTester()
	{
		
		int account0,account1;
		final float InitialAmount=5000;
		
		float amount;
		try
		{
			account0=getAccount(1);
			account1=getAccount(2);
			//an initialize all counts to 5000
			PairTransferThread t0[]=new PairTransferThread[RunningThreadNumber];
			PairTransferThread t1[]=new PairTransferThread[RunningThreadNumber];
			

			System.out.println("thread test begins and we deposit 5000.0 to each account "
								+ " and we are going to run some number of thread to transfer 50 from one to the other," +
				"if server is not properly synchronized, the balance will not be the same probably");
			Deposit(account0, InitialAmount);
			Deposit(account1, InitialAmount);
			System.out.println("account "+account0+" has balance of "+Balance(account0));
			System.out.println("account "+account1+" has balance of "+Balance(account1));

			for (int i=0; i<RunningThreadNumber; i++)
			{
				t0[i]=new PairTransferThread(account0,account1, 50);
				t0[i].start();
				t1[i]=new PairTransferThread(account1,account0, 50);
				t1[i].start();			
			}
			
		
			while (counter<RunningThreadNumber*2)
			{
				Thread.sleep(2000);
			}
			
			

			for (int i=0; i<RunningThreadNumber; i++)
			{
				t0[i].join();
				t1[i].join();				
			}
			

			System.out.println("thread test is over and let's check if the balance of account remains same as before");
			
			System.out.println("account "+account0+" has balance of "+Balance(account0));
			System.out.println("account "+account1+" has balance of "+Balance(account1));

		}
		catch (Exception er)
		{
			System.out.println("transfer thread error of "+ er.getMessage());
		}
	}

	protected static void transferTester()
	{
		final int MaxTransferAccount=3;
		int accounts[]=new int[MaxTransferAccount];
		final float InitialAmount=5000;
		int index1, index2;
		float amount;
		try
		{
			for (int i=0; i<MaxTransferAccount; i++)
			{
				//accounts[i]=getAccount(rand.nextInt(BankUtility.MaxBranchNumber));
				accounts[i]=getAccount(i+1);
				Deposit(accounts[i], InitialAmount);
			}
			
			//an initialize all counts to 5000
			transferThread0=new TransferThread[RunningThreadNumber];
			transferThread1=new TransferThread[RunningThreadNumber];
			transferThread2=new TransferThread[RunningThreadNumber];

			System.out.println("thread test begins and we deposit 5000.0 to each account "
				+ " and we are going to run some number of thread to transfer 50 from one to the other," +
				"if server is not properly synchronized, the balance will not be the same probably");
			for (int i=0; i<MaxTransferAccount; i++)
			{
				System.out.println("account "+accounts[i]+" balance is "+Balance(accounts[i]));
			}
	
			for (int i=0; i<RunningThreadNumber; i++)
			{
				transferThread0[i]=new TransferThread(accounts[0],accounts[1], 50);
				transferThread0[i].start();
				transferThread1[i]=new TransferThread(accounts[1],accounts[2], 50);
				transferThread1[i].start();
				transferThread2[i]=new TransferThread(accounts[2],accounts[0], 50);
				transferThread2[i].start();
			}
			
		
			while (counter<RunningThreadNumber*3)
			{
				Thread.sleep(2000);
			}
			
			

			for (int i=0; i<RunningThreadNumber; i++)
			{
				transferThread0[i].join();
				transferThread1[i].join();
				transferThread2[i].join();
			}
			

			System.out.println("thread test is over and let's check if the balance of account remains same as before");
			
			for (int i=0; i<MaxTransferAccount; i++)
			{
				System.out.println("account "+accounts[i]+" balance is "+Balance(accounts[i]));
			}		
		}
		catch (Exception er)
		{
			System.out.println("transfer thread error of "+ er.getMessage());
		}
	}


	protected static void threadTester()
	{
		int account;		
		float amount;
		try
		{
			account=Open();//open a new account;
			
			amount=Deposit(account, 3000);
			deposits=new RunningThread[RunningThreadNumber];
			withdraws=new RunningThread[RunningThreadNumber];
			System.out.println("thread test begins and we deposit 3000.0 to account " 
				+ Integer.toString(account)
				+ " and we are going to run equal number of deposit and withdraw actions," +
				"if server is not properly synchronized, the balance will not be the same probably");

			System.out.println("the balance of account "+ Integer.toString(account) + " is "
				+ Float.toString(amount));


			for (int i=0; i<RunningThreadNumber; i++)
			{
				deposits[i]=new RunningThread(account, 50);
				deposits[i].start();
				withdraws[i]=new RunningThread(account, -50);
				withdraws[i].start();
			}

			for (int i=0; i<RunningThreadNumber; i++)
			{
				deposits[i].join();
				withdraws[i].join();
			}

			System.out.println("thread test is over and let's check if the balance of account remains same as before");
			
			System.out.println("the balance of "+Integer.toString(account) + " is " +
				Float.toString(Balance(account)));
		}
		catch (Exception er)
		{
			System.out.println(er.getMessage());
		}
	}


	protected static void manualTester()
	{
		//now do the test
		int choice=0;
		int account, dest;
		float amount;

		do
		{			
			//bufOutput.writeBytes(menuStr);
			System.out.println(menuStr);
			
			try
			{
				choice = Integer.parseInt(bufInput.readLine());
				float result = 0;
				boolean done = false;
				int retry = 0;
				switch(choice)
				{
					case 1:
						//randomly choose a server
						//bufOutput.writeBytes("new opened account is" + Integer.toString(account)+"\n");
						int newAcnt = 0;
						
						// Retry if the remote object is shut down
						retry = 0;
						done = false;
						while(!done && retry<10){
							try{
								newAcnt = Open();
								done = true;
							}catch(Exception e){
								if(e.getMessage().indexOf("cannot bind branch")!=-1){
									// Can not find branch server
									System.out.println("The branch server is not start up.");
									done=false;
									break;
								}
								retry++;
							}
						}
						if(done==false){
							continue;
						}
						System.out.println("new opened account is " + newAcnt);
						break;
					case 2:
						//bufOutput.writeBytes("input account no.\n");
						System.out.println("input account no.");
						account=Integer.parseInt(bufInput.readLine());
						if (!checkAccount(account))
						{
							System.out.println("invalid account number!");
							break;
						}
						//bufOutput.writeBytes("input amount to deposit:\n");
						System.out.println("input amount to deposit:");
						amount=Float.parseFloat(bufInput.readLine());

						// Retry if the remote object is shut down
						retry = 0;
						done = false;
						while(!done && retry<10){
							try{
								result = Deposit(account, amount);
								done = true;
							}catch(Exception e){
								if(e.getMessage().indexOf("cannot bind branch")!=-1){
									// Can not find branch server
									System.out.println("The branch server is not start up.");
									done=false;
									break;
								}
								retry++;
							}
						}
						if(done==false){
							continue;
						}
						if(result==BankUtility.NegativeInfinite){
							System.out.println("Operation failed, the account does not exist.");
						}else{
							System.out.println("new balance is "+result);
						}
						break;
					case 3:
						//bufOutput.writeBytes("input account no.\n");
						System.out.println("input account no");
						account=Integer.parseInt(bufInput.readLine());
						//bufOutput.writeBytes("input amount to withdraw:\n");
						if (!checkAccount(account))
						{
							System.out.println("invalid account number!");
							break;
						}
						System.out.println("input amount to withdraw:");
						amount=Float.parseFloat(bufInput.readLine());
						
						// Retry if the remote object is shut down
						retry = 0;
						done = false;
						while(!done && retry<10){
							try{
								result = Withdraw(account, amount);
								done = true;
							}catch(Exception e){
								if(e.getMessage().indexOf("cannot bind branch")!=-1){
									// Can not find branch server
									System.out.println("The branch server is not start up.");
									done=false;
									break;
								}
								retry++;
							}
						}
						if(done==false){
							continue;
						}
						if(result==BankUtility.NegativeInfinite){
							System.out.println("Operation failed, the account does not exist or not enough money.");
						}else{
							System.out.println("new balance is "+result);
						}

						break;
					case 4:
						//bufOutput.writeBytes("input account no.\n");
						System.out.println("input account no");
						account=Integer.parseInt(bufInput.readLine());
						if (!checkAccount(account))
						{
							System.out.println("invalid account number!");
							break;
						}
						//get server
						
						//bufOutput.writeBytes("balance of account " + Integer.toString(account)+
						//	" is " + Float.toString(h.Balance(account))+ "\n");

						// Retry if the remote object is shut down
						retry = 0;
						done = false;
						while(!done && retry<10){
							try{
								result = Balance(account);
								done = true;
							}catch(Exception e){
								if(e.getMessage().indexOf("cannot bind branch")!=-1){
									// Can not find branch server
									System.out.println("The branch server is not start up.");
									done=false;
									break;
								}
								retry++;
							}
						}
						if(done==false){
							continue;
						}
						if(result==BankUtility.NegativeInfinite){
							System.out.println("Account does not exist.");
						}else{
							System.out.println("balance of account " + Integer.toString(account)+
									" is " + result);
						}
						break;
					case 5:
						//bufOutput.writeBytes("input account no.\n");
						System.out.println("input source account no");
						account=Integer.parseInt(bufInput.readLine());
						if (!checkAccount(account))
						{
							System.out.println("invalid account number!");
							break;
						}
						System.out.println("input destination account no");
						dest=Integer.parseInt(bufInput.readLine());
						if (!checkAccount(account))
						{
							System.out.println("invalid account number!");
							break;
						}
						System.out.println("input amount to transfer");
						amount=Float.parseFloat(bufInput.readLine());
						
						// Retry if the remote object is shut down
						retry = 0;
						done = false;
						while(!done && retry<10){
							try{
								result = Transfer(account, dest, amount);
								done = true;
							}catch(Exception e){
								if(e.getMessage().indexOf("cannot bind branch")!=-1){
									// Can not find branch server
									System.out.println("The branch server is not start up.");
									done=false;
									break;
								}
								retry++;
							}
						}
						if(done==false){
							continue;
						}
						if(result==BankUtility.NegativeInfinite){
							System.out.println("Operation failed, the account does not exist or not enough money.");
						}else{
							System.out.println("transfer "+ Float.toString(amount) + " from "+ Integer.toString(account)
									+ " to " +Integer.toString(dest) + " and balance of source account is " + 
									result);
						}
						break;
						
					case 6:
						//bufOutput.writeBytes("exiting test\n");
						System.out.println("exiting test\n");
						break;
					default:
						//bufOutput.writeBytes("please input choice between 1 to 5.\n");
						System.out.println("please input choice between 1 to 5.");
						break;
				}
			}
			catch (Exception er)
			{
				System.out.println(er.getMessage());
			}

		}
		while (choice!=6);
	}


	protected static void autoTester()
	{
		int branchNum = 3;
		final int MaxAmount=1000;
		
		int choice, account, dest;
		float amount;
		
		for (int i=0; i<100; ++i)
		{
			if(i%20==1) System.out.println("20 tests done");
			try
			{
				//purely for testing
				//choice=0;
				choice=rand.nextInt(5);
				switch (choice)
				{
				case 0:
					//open
					System.out.println("try to open a new account");
					System.out.println("a new opened account is " +Integer.toString(Open()));
					break;
				case 1:
					//deposit
					account=(rand.nextInt(branchNum)+BankUtility.BranchIDOffset)*10000
						+rand.nextInt(10000);
					amount=rand.nextInt(MaxAmount)+rand.nextInt(100)/(float)100.0;
					System.out.println("try to deposit account "+Integer.toString(account)+" amount of " 
						+ Float.toString(amount));
					
					System.out.println("account "+Integer.toString(account)+" is deposited with "+Float.toString(amount)
						+ " and new balance is "+ Float.toString(Deposit(account, amount)));
					break;
				case 2:
					//withdraw
					account=(rand.nextInt(branchNum)+BankUtility.BranchIDOffset)*10000
						+rand.nextInt(10000);
					//i want to use float with two digits after point
					amount=rand.nextInt(MaxAmount)+rand.nextInt(100)/(float)100.0;
					System.out.println("try to withdraw account "+Integer.toString(account)+" amount of " 
						+ Float.toString(amount));
					
					System.out.println("account "+Integer.toString(account)+" is withdraw with "+Float.toString(amount)
						+" and new balance is " + Float.toString(Withdraw(account, amount)));
					break;
				case 3:
					//balance
					account=(rand.nextInt(branchNum)+BankUtility.BranchIDOffset)*10000
						+rand.nextInt(10000);
					System.out.println("try to get balance of account "+Integer.toString(account));
					amount=Balance(account);
					System.out.println("account "+Integer.toString(account)+" has balance of "+Float.toString(amount));
					break;
				case 4:
					account=(rand.nextInt(branchNum)+BankUtility.BranchIDOffset)*10000
						+rand.nextInt(10000);
					dest=(rand.nextInt(branchNum)+BankUtility.BranchIDOffset)*10000
						+rand.nextInt(10000);

					//i want to use float with two digits after point
					amount=rand.nextInt(MaxAmount)+rand.nextInt(100)/(float)100.0;
					System.out.println("try to transfer from account "+Integer.toString(account)+" amount of " 
						+ Float.toString(amount)+  "to account "+dest+"result="+Transfer(account, dest,amount));

					break;
				}
			}
			catch(Exception er)
			{
				System.out.println(er.getMessage());
			}
		}
	}
	
}
