package ServerConfig;

import ServerConfig.loader.*;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import org.omg.CORBA.ORB;

/**
 * @author Min Huang (khtwo) Call the LoaderServant to remotely start up a program
 * 
 */
public class LoaderClient {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		while (true) {
			Thread.setDefaultUncaughtExceptionHandler(new MyExceptionHandler());

			try {
				// Instantiate the ORB
				ORB orb = ORB.init(args, null);

/*
				// get the root naming context
				org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
				NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);

				// resolve the Object Reference in Naming
				// String name = "loaderServant";
				String name = args[0];
				ProgramLoader loader = ProgramLoaderHelper.narrow(ncRef.resolve_str(name));
*/
				String corbaname = "corbaname::192.168.88.60:3002#Branches/Branch001/Server1/loaderBranch001-1";
				System.out.println(corbaname);
				org.omg.CORBA.Object obj = orb.string_to_object(corbaname);
				ProgramLoader loader = ProgramLoaderHelper.narrow(obj);
				
				// Remote execute the command
				BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
				String command[] = new String[2];
				command[0] = "java ServerConfig.tester 0";
				command[1] = "java ServerConfig.tester 1";
				while (true) {
					System.out.println("Select option 0 or 1");
					int selection = 0;
					try {
						selection = Integer.parseInt(input.readLine());
					}
					catch (NumberFormatException ex) {
						System.out.println("You have input a invalid branch ID, exit.");
						System.exit(1);
					}

					boolean isSucceeded = false;
					while (!isSucceeded) {
						try {
							if(selection!=0 && selection!=1) selection = 0;
							obj = orb.string_to_object(corbaname);
							loader = ProgramLoaderHelper.narrow(obj);
							System.out.println(loader.loadProgram(command[selection]));
							isSucceeded = true;
						}
						catch (Throwable e) {
							obj = orb.string_to_object(corbaname);
							loader = ProgramLoaderHelper.narrow(obj);
							System.out.println("Exception! Reconnect to the orb server");
							// Sleep for 2 seconds
							try {
								Thread.sleep(2000);
							}
							catch (InterruptedException s) {
								System.out.println("Sleep failed");
							}
						}
					}
				}
			}
			catch (Throwable e) {
				System.out.println("Exception! Reconnect to the orb server");
			}
		}
	}
}


class MyExceptionHandler implements Thread.UncaughtExceptionHandler{

	public void uncaughtException(Thread t, Throwable e) {
		System.out.println("Unhandled Exception happened");
	}
	
}